Scroll Settings in EJ2 JavaScript Diagram

7 Aug 202624 minutes to read

The diagram can be scrolled using both the vertical and horizontal scrollbars. Additionally, the mouse wheel can be used to scroll the diagram. The diagram’s scrollSettings allow you to read the current scroll status, view port size, current zoom level, and zoom factor. These settings also provide the capability to programmatically control the scrolling of the diagram.

Access and Customize Scroll Settings

Scroll settings in a diagram allow you to access and customize various properties such as horizontalOffset, verticalOffset, viewPortWidth, viewPortHeight, currentZoom, zoomFactor, maxZoom, minZoom, scrollLimit , canAutoScroll , autoScrollBorder, padding , scrollableArea.

These properties enable you to read and adjust the scroll status, scroll offset, zoom levels, and more. For a comprehensive overview of these properties, refer to the Scroll Settings

Define scroll offset

The diagram allows you to pan before loading, ensuring that any desired region of a large diagram is visible. You can programmatically pan the diagram using the horizontalOffset and verticalOffset properties of the scroll settings. The following code illustrates how to programmatically pan the diagram upon initialization also defined scrollLimit as Infinity to scroll infinitely in diagram. To learn more about scroll limit refer to scrollLimit.

In the example below, the vertical scrollbar is scrolled down by 100 px, and the horizontal scrollbar is scrolled to the right by 100 px.

var diagram;
diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '700px',
    rulerSettings: { showRulers: true },
    scrollSettings: {
      //To scroll the diagram infinitely
      scrollLimit: 'Infinity',
    },
    created: created,
  },
  '#element'
);
function created() {
  setTimeout(() => {
    diagram.scrollSettings.horizontalOffset = 100;
    diagram.scrollSettings.verticalOffset = 100;
    diagram.dataBind();
  });
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Update scroll offset at runtime

There are several ways to update the scroll offset at runtime:

  • Scrollbar: Use the horizontal and vertical scrollbars of the diagram.
  • Mousewheel: Scroll vertically with the mouse wheel. Hold the Shift key while scrolling to scroll horizontally.
  • Pan Tool: Activate the ZoomPan tool in the diagram to scroll by panning.
  • Touch: Use touch pad gestures for scrolling.

Programmatically update Scroll Offset

You can programmatically change the scroll offsets of diagram by customizing the horizontalOffset and verticalOffset of Scroll Settings at runtime. The following code illustrates how to change the scroll offsets at runtime.

var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '700px',
      nodes: [{ offsetX: 300, offsetY: 300 }],
      rulerSettings: { showRulers: true },
      scrollSettings: { scrollLimit: 'Infinity' },
    },
    '#element'
  );
  
  document.getElementById('updateScrollerOffset').onclick = () => {
    // Updates scroll settings
    diagram.scrollSettings.horizontalOffset = 200;
    diagram.scrollSettings.verticalOffset = 100;
    diagram.dataBind();
  };
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="updateScrollerOffset" id="updateScrollerOffset" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Update zoom at runtime

Zoom using mouse wheel

Another way to zoom in and out the diagram is by using the mouse wheel. This method is a quick and convenient way to zoom in and out without having to use any additional tools or gestures.

  • Zoom in: Press Ctrl+mouse wheel, then scroll upward.

  • Zoom out: Press Ctrl+mouse wheel, then scroll downward.

Zoom using Keyboard Shortcuts

Using keyboard shortcuts is a quick and easy way to zoom the diagram without having to use the mouse or touch pad.

  • Zoom in: Press Ctrl and the plus(+) key.

  • Zoom out: Press Ctrl and the minus(-) key.

Programmatically update zoom

You can programmatically change the current zoom of diagram by utilizing the zoomTo public method.

ZoomOptions

The zoomTo method takes one parameter zoomOptions. In that zoomOptions we can specify the focusPoint, type and zoomFactor

The following example shows how to zoom-in and zoom-out the diagram using zoomTo method

var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '700px',
    nodes: [{ offsetX: 300, offsetY: 300 }],
    rulerSettings: { showRulers: true },
    scrollSettings: { scrollLimit: 'Infinity' },
  },
  '#element'
);

document.getElementById('zoomIn').onclick = () => {
  // Zoom options to zoom-in
  let zoomOptions = {
    type: 'ZoomIn',
    zoomFactor: 0.2,
    focusPoint: { x: 0.5, y: 0.5 },
  };
  diagram.zoomTo(zoomOptions);
  diagram.dataBind();
};

document.getElementById('zoomOut').onclick = () => {
  // Zoom options to zoom-out
  let zoomOptions = {
    type: 'ZoomOut',
    zoomFactor: 0.2,
    focusPoint: { x: 0.5, y: 0.5 },
  };
  diagram.zoomTo(zoomOptions);
  diagram.dataBind();
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="zoomIn" id="zoomIn" />
      <input type="button" value="zoomOut" id="zoomOut" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

For more information on various ways to zoom and pan the diagram, refer to zoomPan with various ways

AutoScroll

The autoscroll feature automatically scrolls the diagram when a node or connector is moved beyond its boundary. This ensures that the element remains visible during operations like dragging, resizing, and selection.

The autoscroll behavior triggers automatically when any of the following actions occur towards the edges of the diagram:

  • Node dragging or resizing
  • Connector control point editing
  • Rubber band selection

The client-side event ScrollChange is triggered when autoscroll occurs, allowing for customizations. Refer scrollChange-event for more information.

Autoscroll behavior can be enabled or disabled using the canAutoScroll property of the diagram.

Autoscroll border

The autoscroll border defines the maximum distance from the mouse pointer to the diagram edge that triggers autoscroll. By default, this distance is set to 15 pixels for all sides (left, right, top, and bottom). You can adjust this using the autoScrollBorder property of the scroll settings.

The following example demonstrates how to configure autoscroll:

var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '700px',
      connectors: [
        {
          id: 'con1',
          type: 'Bezier',
          segments: [{ type: 'Bezier', point: { x: 150, y: 100 } }],
          sourcePoint: { x: 100, y: 100 },
          targetPoint: { x: 300, y: 100 },
          annotations: [
            {
              content: 'Adjust control point or end point to autoScroll',
              alignment: 'After',
            },
          ],
          constraints:
            ej.diagrams.ConnectorConstraints.Default |
            ej.diagrams.ConnectorConstraints.DragSegmentThumb,
        },
      ],
      nodes: [
        {
          id: 'node1',
          width: 100,
          height: 60,
          offsetX: 200,
          offsetY: 300,
          annotations: [
            { content: 'Drag or resize the node to activate autoscroll' },
          ],
        },
      ],
      //Enables ruler to see the scroll offset
      rulerSettings: { showRulers: true },
      scrollSettings: {
        scrollLimit: 'Infinity',
        //Enable autoScroll
        canAutoScroll: true,
        //Defines the autoScroll border of all the sides of diagram
        autoScrollBorder: { left: 100, right: 100, top: 100, bottom: 100 },
      },
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

NOTE

To use auto scroll the scrollLimit should be set as Infinity.

Controlling Autoscroll Speed

You can control how often the scrolling needs to be performed automatically in the Diagram component during the auto-scrolling behavior. You can now adjust the frequency, ranging from slow and smooth to quick and rapid, to suit their preferences. To configure, set the value in milliseconds to the autoScrollFrequency property within the scrollSettings class, allowing precise control over how often auto-scrolling occurs.

AutoscrollFrequency GIF

Scroll limit

The scrollLimit allows you to define the scrollable region of the diagram. It includes the following options:

  • Infinity: Allows scrolling in all directions without any restriction.
  • Diagram: Allows scrolling within the diagram region.
  • Limited: Allows scrolling within a specified scrollable area.

The scrollLimit property in scroll settings helps to define these limits.

Scrollable Area

Scrolling beyond a particular rectangular area can be restricted by using the scrollableArea property in scrollSettings. To restrict scrolling beyond a custom region, set the scrollLimit to Limited and define the desired bounds in scrollableArea property.

The following code example illustrates how to specify the scroll limit and customize the scrollable area.

var nodes = [
    {
      id: 'Start',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 50,
      style: { fill: '#6BA5D7' },
      annotations: [
        {
          id: 'label1',
          content: 'Start',
        },
      ],
      shape: {
        type: 'Flow',
        shape: 'Terminator',
      },
    },
  ];
  //ScrollableArea from 0 to 1500 in horizontal axis and 0 to 1500 in vertical axis
  var area = new ej.diagrams.Rect(0, 0, 1500, 1500);
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      nodes: nodes,
      rulerSettings: { showRulers: true },
      // set the autoScrollBorder
      scrollSettings: {
        canAutoScroll: true,
        //Sets the scroll limit
        scrollLimit: 'Limited',
        //Sets scrollableArea
        scrollableArea: area,
      },
    },
    '#element'
  );
  //To change scroll limit dynamically.
  document.getElementById('scrollLimit').onchange = (args) => {
    diagram.scrollSettings.scrollLimit = args.target.value;
    diagram.dataBind();
  };
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <label>Scrollable Area</label>
        <select id="scrollLimit">
          <option value="Limited">Limited</option>
          <option value="Infinity">Infinity</option>
          <option value="Diagram">Diagram</option>
        </select>
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Scroll Padding

The padding property of the scroll settings allows you to extend the scrollable region based on the scroll limit. This property is useful for adding extra space around the diagram content, making it easier to navigate and interact with elements near the edges.

The following code example illustrates how to set scroll padding for the diagram region:

var nodes = [
    {
      id: 'Start',
      width: 140,
      height: 50,
      offsetX: 300,
      offsetY: 50,
      style: { fill: '#6BA5D7', strokeColor: 'white' },
      annotations: [
        {
          id: 'label1',
          content: 'Start',
        },
      ],
      shape: {
        type: 'Flow',
        shape: 'Terminator',
      },
    },
  ];
  //ScrollableArea from 0 to 1500 in horizontal axis and 0 to 1500 in vertical axis
  var area = new ej.diagrams.Rect(0, 0, 1500, 1500);
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      nodes: nodes,
      rulerSettings: { showRulers: true },
      scrollSettings: {
        // sets the scroll padding
        padding: { left: 100, top: 100 },
      },
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Reset scroll

The reset method resets the zoom and scroller offsets to their default values.

//Resets the scroll and zoom to default values
 diagram.reset();

UpdateViewport

The updateViewPort method is used to update the dimensions of the diagram viewport.

//Updates diagram viewport
diagram.updateViewPort();

Events

Scroll change event

The scrollChange event is triggered whenever the scrollbar is updated. This can occur during actions such as zooming in, zooming out, using the mouse wheel, or panning. The following example shows how to capture the scrollChange event.

let nodes = [
  {
    id: 'Start',
    width: 140,
    height: 50,
    offsetX: 300,
    offsetY: 50,
    annotations: [
      {
        content: 'Node 1',
      },
    ],
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
  },
];
var diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '600px',
  nodes: nodes,
  tool: ej.diagrams.DiagramTools.ZoomPan,
  scrollChange: function (args) {
    console.log(args.panState);
    //customize
  },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Scroll Settings in React Diagram

6 Aug 202624 minutes to read

The diagram component provides comprehensive scrolling capabilities through both vertical and horizontal scrollbars, as well as mouse wheel navigation. The diagram’s scrollSettings enable developers to monitor the current scroll status, viewport dimensions, zoom levels, and programmatically control diagram navigation. These settings are essential for managing large diagrams and providing smooth user interaction experiences.

Access and Customize Scroll Settings

Scroll settings in a diagram provide access to various properties that control navigation and viewport behavior, including horizontalOffset, verticalOffset, viewPortWidth, viewPortHeight, currentZoom, zoomFactor, maxZoom, minZoom, scrollLimit, canAutoScroll, autoScrollBorder, padding, scrollableArea.

These properties enable developers to read and adjust the scroll status, scroll offsets, zoom levels, and scrolling behavior. For a comprehensive overview of all available properties, refer to the Scroll Settings

Define Scroll Offset

The diagram allows developers to set the initial scroll position before loading, ensuring that any desired region of a large diagram is immediately visible. The initial scroll position can be programmatically configured using the horizontalOffset and verticalOffset properties of the scroll settings. The following code illustrates how to programmatically set the diagram’s initial scroll position upon initialization, with scrollLimit defined as ‘Infinity’ to enable infinite scrolling. To learn more about scroll limits, refer to the scrollLimit

In the example below, the vertical scrollbar is scrolled down by 100 px, and the horizontal scrollbar is scrolled to the right by 100 px.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
//Sets scroll status
let diagramInstance;
function App() {
    return (<DiagramComponent id="container" ref={(diagram) => (diagramInstance = diagram)} width={700} height={700} rulerSettings= scrollSettings=
        created={() => {
            diagramInstance.scrollSettings.horizontalOffset = 100;
            diagramInstance.scrollSettings.verticalOffset = 100;
            diagramInstance.dataBind();
        }}/>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    DiagramComponent
} from "@syncfusion/ej2-react-diagrams";
//Sets scroll status
let diagramInstance: DiagramComponent;
function App() {
  return (
    <DiagramComponent
      id="container"
      ref={(diagram) => (diagramInstance = diagram)}
      width={700}
      height={700}
      rulerSettings=
      scrollSettings=
      created={() => {
        diagramInstance.scrollSettings.horizontalOffset = 100;
        diagramInstance.scrollSettings.verticalOffset = 100;
        diagramInstance.dataBind();
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Update Scroll Offset at Runtime

The diagram provides multiple methods to update scroll offsets during runtime:

  • Scrollbar: Use the horizontal and vertical scrollbars of the diagram for direct navigation.
  • Mouse wheel: Scroll vertically with the mouse wheel. Hold the Shift key while scrolling to scroll horizontally.
  • Pan Tool: Activate the ZoomPan tool in the diagram to scroll by panning.
  • Touch: Use touch pad gestures for smooth scrolling on touch-enabled devices.

Programmatically Update Scroll Offset

The scroll offsets of the diagram can be programmatically modified by customizing the horizontalOffset and verticalOffset of Scroll Settings at runtime. The following code demonstrates how to change the scroll offsets dynamically.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
let diagramInstance;
let node = [{
    offsetX: 300,
    offsetY: 300
}]
function App() {
    const updateOffset = () => {
        diagramInstance.scrollSettings.horizontalOffset = 200;
        diagramInstance.scrollSettings.verticalOffset = 100;
        diagramInstance.dataBind();
    };  
    return (
    <div>
        <button id="updateOffset" onClick={updateOffset}>Update Scroller Offset</button>
        <DiagramComponent id="container" ref={(diagram) => (diagramInstance = diagram)} width={700} height={700} nodes={node} rulerSettings= scrollSettings=/>
    </div>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    NodeModel,
    DiagramComponent
} from "@syncfusion/ej2-react-diagrams";
let diagramInstance: DiagramComponent;
let node: NodeModel[] = [{
  offsetX: 300,
  offsetY: 300,
}];
function App() {
  const updateOffset = () => {
    diagramInstance.scrollSettings.horizontalOffset = 200;
    diagramInstance.scrollSettings.verticalOffset = 100;
    diagramInstance.dataBind();
  }; 
  return (
    <div>
      <button id="updateOffset" onClick={updateOffset}>Update Scroller Offset</button>
      <DiagramComponent
        id="container"
        ref={(diagram) => (diagramInstance = diagram)}
        width={700}
        height={700}
        nodes={node}
        rulerSettings=
        scrollSettings=
      />
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Update Zoom at Runtime

Zoom Using Mouse Wheel

The mouse wheel provides a convenient method to zoom in and out of the diagram quickly without requiring additional tools or gestures.

  • Zoom in: Press Ctrl+mouse wheel, then scroll upward.

  • Zoom out: Press Ctrl+mouse wheel, then scroll downward.

Zoom Using Keyboard Shortcuts

Keyboard shortcuts offer a quick and efficient way to zoom the diagram without using the mouse or touch pad.

  • Zoom in: Press Ctrl and the plus (+) key.

  • Zoom out: Press Ctrl and the minus (-) key.

Programmatically Update Zoom

The current zoom level of the diagram can be programmatically modified by utilizing the zoomTo public method.

ZoomOptions

The zoomTo method takes one parameter zoomOptions. In that zoomOptions we can specify the focusPoint, type and zoomFactor

The following example demonstrates how to zoom in and zoom out of the diagram using the zoomTo method:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
let diagramInstance;
let node = [{
    offsetX: 300,
    offsetY: 300
}]
function App() {
    const zoomIn = () => {
        let zoomOptions = {
            type: 'ZoomIn',
            zoomFactor: 0.2,
            focusPoint: { x: 0.5, y: 0.5 },
        };
        diagramInstance.zoomTo(zoomOptions);
        diagramInstance.dataBind();
    };
    const zoomOut = () => {
        let zoomOptions = {
            type: 'ZoomOut',
            zoomFactor: 0.2,
            focusPoint: { x: 0.5, y: 0.5 },
        };
        diagramInstance.zoomTo(zoomOptions);
        diagramInstance.dataBind();
    };  
    return (
    <div>
        <button id="zoomIn" onClick={zoomIn}>Zoom In</button>
        <button id="zoomOut" onClick={zoomOut}>Zoom Out</button>
        <DiagramComponent id="container" ref={(diagram) => (diagramInstance = diagram)} width={700} height={700} nodes={node} rulerSettings= scrollSettings=/>
    </div>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    NodeModel,
    DiagramComponent,
    ZoomOptions
} from "@syncfusion/ej2-react-diagrams";
let diagramInstance: DiagramComponent;
let node: NodeModel[] = [{
  offsetX: 300,
  offsetY: 300,
}];
function App() {
  const zoomIn = () => {
    let zoomOptions: ZoomOptions = {
        type: 'ZoomIn',
        zoomFactor: 0.2,
        focusPoint: { x: 0.5, y: 0.5 },
    };
    diagramInstance.zoomTo(zoomOptions);
    diagramInstance.dataBind();
  };
const zoomOut = () => {
    let zoomOptions: ZoomOptions = {
        type: 'ZoomOut',
        zoomFactor: 0.2,
        focusPoint: { x: 0.5, y: 0.5 },
    };
    diagramInstance.zoomTo(zoomOptions);
    diagramInstance.dataBind();
  };  
  return (
    <div>
      <button id="zoomIn" onClick={zoomIn}>Zoom In</button>
      <button id="zoomOut" onClick={zoomOut}>Zoom Out</button>
      <DiagramComponent
        id="container"
        ref={(diagram) => (diagramInstance = diagram)}
        width={700}
        height={700}
        nodes={node}
        rulerSettings=
        scrollSettings=
      />
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

For more information on various ways to zoom and pan the diagram, refer to zoomPan with various ways

AutoScroll

The autoscroll feature automatically scrolls the diagram when a node or connector is moved beyond the visible boundary. This functionality ensures that elements remain visible during operations such as dragging, resizing, and selection, providing a seamless user experience.

The autoscroll behavior activates automatically when any of the following actions occur near the edges of the diagram:

  • Node dragging or resizing operations.
  • Connector control point editing.
  • Rubber band selection.

The client-side event ScrollChange is triggered when autoscroll occurs, enabling custom behavior implementation. Refer to the scrollChange-event for more information.

Autoscroll behavior can be enabled or disabled using the canAutoScroll property of the diagram.

Autoscroll border

The autoscroll border defines the maximum distance from the mouse pointer to the diagram edge that triggers autoscroll behavior. By default, this distance is set to 15 pixels for all sides (left, right, top, and bottom). This distance can be customized using the autoScrollBorder property of the scroll settings.

The following example demonstrates how to configure autoscroll:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, ConnectorConstraints, ConnectorEditing, Inject  } from "@syncfusion/ej2-react-diagrams";

let connector = [
    {
      id: 'connetor',
      type: 'Bezier',
      segments: [{ type: 'Bezier', point: { x: 150, y: 100 } }],
      sourcePoint: { x: 100, y: 100 },
      targetPoint: { x: 300, y: 100 },
      annotations: [
        {
          content: 'Adjust control point or end point to autoScroll',
          alignment: 'After',
        },
      ],
      constraints:
        ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
    },
  ];
let nodes = [{
    id: 'node1',
    width: 100,
    height: 60,
    offsetX: 200,
    offsetY: 300,
    annotations: [
      { content: 'Drag or resize the node to activate autoscroll' },
    ],
  }];
const scrollSettings = {
    scrollLimit: 'Infinity',
    canAutoScroll: true,
    autoScrollBorder: {
        left: 100,
        right: 100,
        top: 100,
        bottom: 100
    }
};
function App() {
    return (<DiagramComponent id="container" width={'100%'} height={'600px'} nodes={nodes} connectors={connector} rulerSettings=
    scrollSettings={scrollSettings}>
    <Inject services={[ConnectorEditing]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    NodeModel,
    ConnectorModel,
    DiagramComponent,
    ConnectorConstraints,
    ConnectorEditing,
    Inject
} from "@syncfusion/ej2-react-diagrams";
let connector: ConnectorModel[] = [
  {
    id: 'connetor',
    type: 'Bezier',
    segments: [{ type: 'Bezier', point: { x: 150, y: 100 } }],
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 300, y: 100 },
    annotations: [
      {
        content: 'Adjust control point or end point to autoScroll',
        alignment: 'After',
      },
    ],
    constraints:
      ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
  },
];
let nodes: NodeModel[] = [{
  id: 'node1',
  width: 100,
  height: 60,
  offsetX: 200,
  offsetY: 300,
  annotations: [
    { content: 'Drag or resize the node to activate autoscroll' },
  ],
}];
const scrollSettings = {
  scrollLimit: 'Infinity',
  canAutoScroll: true,
  autoScrollBorder: {
    left: 100,
    right: 100,
    top: 100,
    bottom: 100
  }
};
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      nodes={nodes}
      connectors={connector}
      rulerSettings=
      // set the autoScrollBorder
      scrollSettings = {scrollSettings}>
    <Inject services={[ConnectorEditing]}/>
    </DiagramComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

NOTE

To use auto scroll the scrollLimit should be set as ‘Infinity’

Controlling Autoscroll Speed

The frequency of automatic scrolling in the Diagram component during autoscroll behavior can be precisely controlled. The scrolling frequency can be adjusted from slow and smooth to quick and rapid to suit different requirements. Configure this by setting a value in milliseconds to the autoScrollFrequency property within the scrollSettings, allowing precise control over autoscroll timing.

AutoscrollFrequency GIF

Scroll limit

The scrollLimit allows you to define the scrollable region of the diagram. It includes the following options:

  • Infinity: Allows scrolling in all directions without any restriction.
  • Diagram: Allows scrolling within the diagram region only.
  • Limited: Allows scrolling within a specified scrollable area.

The scrollLimit property in scroll settings helps to define these scrolling boundaries.

Scrollable Area

Scrolling beyond a particular rectangular area can be restricted by using the scrollableArea property in scrollSettings. To restrict scrolling beyond a custom region, set the scrollLimit to “limited” and define the desired bounds in scrollableArea property.

The following code example illustrates how to specify the scroll limit and customize the scrollable area.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { Rect, DiagramComponent } from "@syncfusion/ej2-react-diagrams";
let diagramInstance;
let nodes = [{
        id: 'Start',
        width: 140,
        height: 50,
        offsetX: 300,
        offsetY: 50,
        annotations: [{
                id: 'label1',
                content: 'Start'
            }],
        shape: {
            type: 'Flow',
            shape: 'Terminator'
        }
    }];
function App() {
    const scrollableArea = (args) => {
        diagramInstance.scrollSettings.scrollLimit = args.target.value;
        diagramInstance.dataBind();
    };
    return (
    <div>
        <label>Scrollable Area</label>
        <select id="scrollLimit" onChange={scrollableArea}>
        <option value="Limited">Limited</option>
        <option value="Infinity">Infinity</option>
        <option value="Diagram">Diagram</option>
        </select>
        <DiagramComponent id="container" ref={(diagram) => (diagramInstance = diagram)} width={'100%'} height={'600px'} nodes={nodes} rulerSettings= scrollSettings=/>
    </div>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    NodeModel,
    ConnectorModel,
    Rect,
    DiagramComponent
} from "@syncfusion/ej2-react-diagrams";
let diagramInstance: DiagramComponent;
let nodes: NodeModel[] = [{
    id: 'Start',
    width: 140,
    height: 50,
    offsetX: 300,
    offsetY: 50,
    annotations: [{
        id: 'label1',
        content: 'Start'
    }],
    shape: {
        type: 'Flow',
        shape: 'Terminator'
    }
}];
function App() {
  const scrollableArea = (args: any) => {
    diagramInstance.scrollSettings.scrollLimit = args.target.value;
    diagramInstance.dataBind();
  };
  return (
    <div>
      <label>Scrollable Area</label>
      <select id="scrollLimit" onChange={scrollableArea}>
        <option value="Limited">Limited</option>
        <option value="Infinity">Infinity</option>
        <option value="Diagram">Diagram</option>
      </select>
      <DiagramComponent
        id="container"
        ref={(diagram) => (diagramInstance = diagram)}
        width={'100%'}
        height={'600px'}
        nodes={nodes}
        rulerSettings=
        scrollSettings=
      />
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Scroll Padding

The padding property of the scroll settings allows you to extend the scrollable region based on the scroll limit. This property is useful for adding extra space around the diagram content, making it easier to navigate and interact with elements near the edges.

The following code example illustrates how to set scroll padding for the diagram region:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
let nodes = [{
        id: 'node',
        width: 100, height: 100,
        offsetX: 350, offsetY: 350,
    }];

const scrollSettings = {
    //Sets the scroll padding
    padding: { left: 100, top: 100 }
};

function App() {
    return (<DiagramComponent id="container" width={'100%'} height={'600px'} nodes={nodes} rulerSettings= scrollSettings={scrollSettings}/>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    NodeModel,
    DiagramComponent
} from "@syncfusion/ej2-react-diagrams";
let nodes: NodeModel[] = [{
    id: 'node',
    width: 100, height: 100,
    offsetX: 350, offsetY: 350,
}];
const scrollSettings = {
  //Sets the scroll padding
  padding: { left: 100, top: 100 }
};
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      nodes={nodes}
      rulerSettings=
      scrollSettings={scrollSettings}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Reset scroll

The reset method resets both the zoom level and scroller offsets to their default values. This is useful for returning the diagram to its initial state after user interactions.

//Resets the scroll and zoom to default values
diagramInstance.reset();

Update Viewport Dimensions

The updateViewPort method is used to update the dimensions of the diagram viewport. This method is typically called when the diagram container size changes or when dynamic resizing is required.

//Updates diagram viewport
diagramInstance.updateViewPort();

Events

Scroll Change Event

The scrollChange event is triggered whenever the scrollbar is updated. This can occur during actions such as zooming in, zooming out, using the mouse wheel, or panning. The following example shows how to capture the scrollChange event.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, DiagramTools } from "@syncfusion/ej2-react-diagrams";
let nodes = [{
        id: 'Start',
        width: 140,
        height: 50,
        offsetX: 300,
        offsetY: 50,
        annotations: [{
            id: 'label1',
            content: 'Rectangle'
        }],
    }];
let tool = DiagramTools.ZoomPan;
function App() {
    const scrollChange= (args) => {
        console.log(args.panState);
        //Handle scrollChange event for custom logic
      };  
    return (<DiagramComponent id="container" width={'100%'} height={'600px'} tool={tool} nodes={nodes} scrollSettings=
        scrollChange={scrollChange} />);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    NodeModel,
    DiagramComponent,
    DiagramTools,
    IScrollChangeEventArgs
} from "@syncfusion/ej2-react-diagrams";
let nodes: NodeModel[] = [{
  id: 'Start',
  width: 140,
  height: 50,
  offsetX: 300,
  offsetY: 50,
  annotations: [{
    id: 'label1',
    content: 'Rectangle'
  }],
}];
let tool: DiagramTools = DiagramTools.ZoomPan;
function App() {
  const scrollChange= (args: IScrollChangeEventArgs) => {
    console.log(args.panState);
    //Handle scrollChange event for custom logic
  }; 
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      tool={tool}
      nodes={nodes}
      scrollSettings=
      scrollChange={scrollChange}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Scroll Settings in Angular Diagram

6 Aug 202624 minutes to read

The diagram component provides comprehensive scrolling capabilities through both vertical and horizontal scrollbars, as well as mouse wheel navigation. The diagram’s scrollSettings enable developers to monitor the current scroll status, viewport dimensions, zoom levels, and programmatically control diagram navigation. These settings are essential for managing large diagrams and providing smooth user interaction experiences.

Access and Customize Scroll Settings

Scroll settings in a diagram provide access to various properties that control navigation and viewport behavior, including horizontalOffset, verticalOffset, viewPortWidth, viewPortHeight, currentZoom, zoomFactor, maxZoom, minZoom, scrollLimit, canAutoScroll, autoScrollBorder, autoScrollFrequency, padding, and scrollableArea.

These properties enable developers to read and adjust the scroll status, scroll offsets, zoom levels, and scrolling behavior. For a comprehensive overview of all available properties, refer to the Scroll Settings API documentation.

Define Scroll Offset

The diagram allows developers to set the initial scroll position before loading, ensuring that any desired region of a large diagram is immediately visible. The initial scroll position can be programmatically configured using the horizontalOffset and verticalOffset properties of the scroll settings. The following code illustrates how to programmatically set the diagram’s initial scroll position upon initialization, with scrollLimit defined as ‘Infinity’ to enable infinite scrolling. To learn more about scroll limits, refer to the scrollLimit section.

In the example below, the vertical scrollbar is positioned 100 pixels down, and the horizontal scrollbar is positioned 100 pixels to the right.

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, Diagram, ScrollSettingsModel, RulerSettingsModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [scrollSettings]="scrollSettings" [rulerSettings]="rulerSettings" (created)='created($event)'>
        <e-nodes>
            <e-node id='node1' [offsetX]=200 [offsetY]=200>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public rulerSettings: RulerSettingsModel = { showRulers: true}
    public scrollSettings?: ScrollSettingsModel;
    ngOnInit(): void {
        // Defines the pageSettings for the diagram
        this.scrollSettings = {
            scrollLimit: 'Infinity',
        }
    }
    //Sets scroll status
    public created(args: Object): void {
        (this.diagram as Diagram).scrollSettings.horizontalOffset = 100;
        (this.diagram as Diagram).scrollSettings.verticalOffset = 100;
        (this.diagram as Diagram).dataBind();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Update Scroll Offset at Runtime

The diagram provides multiple methods to update scroll offsets during runtime:

  • Scrollbar: Use the horizontal and vertical scrollbars of the diagram for direct navigation.
  • Mouse wheel: Scroll vertically with the mouse wheel. Hold the Shift key while scrolling to scroll horizontally.
  • Pan Tool: Activate the ZoomPan tool in the diagram to scroll by panning.
  • Touch: Use touch pad gestures for smooth scrolling on touch-enabled devices.

Programmatically Update Scroll Offset

The scroll offsets of the diagram can be programmatically modified by customizing the horizontalOffset and verticalOffset properties of Scroll Settings at runtime. The following code demonstrates how to change the scroll offsets dynamically.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, Diagram, RulerSettingsModel, ScrollSettingsModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <div class="button">
        <button id="UpdateScrollOffset" (click)='onClick($event)'>Update Scroll Offset</button>
    </div>
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [rulerSettings]="rulerSettings" [scrollSettings]="scrollSettings">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public rulerSettings: RulerSettingsModel = { showRulers: true}
    public scrollSettings?: ScrollSettingsModel = {
        scrollLimit: 'Infinity',
    }
    onClick = (args: MouseEvent) => {
        //Updates scroll settings
        (this.diagram as Diagram).scrollSettings.horizontalOffset = 200;
        (this.diagram as Diagram).scrollSettings.verticalOffset = 100;
        (this.diagram as Diagram).dataBind();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Update Zoom at Runtime

Zoom Using Mouse Wheel

The mouse wheel provides a convenient method to zoom in and out of the diagram quickly without requiring additional tools or gestures.

  • Zoom in: Press Ctrl+mouse wheel, then scroll upward.

  • Zoom out: Press Ctrl+mouse wheel, then scroll downward.

Zoom Using Keyboard Shortcuts

Keyboard shortcuts offer a quick and efficient way to zoom the diagram without using the mouse or touch pad.

  • Zoom in: Press Ctrl and the plus (+) key.

  • Zoom out: Press Ctrl and the minus (-) key.

Programmatically Update Zoom

The current zoom level of the diagram can be programmatically modified by utilizing the zoomTo public method.

ZoomOptions

The zoomTo method accepts one parameter: zoomOptions. Within zoomOptions, developers can specify the focusPoint, type, and zoomFactor.

The following example demonstrates how to zoom in and zoom out of the diagram using the zoomTo method:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, Diagram, RulerSettingsModel, ScrollSettingsModel, ZoomOptions } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <div class="button">
        <button id="zoomIn" (click)='onZoomInClick($event)'>Zoom In</button>
        <button id="zoomOut" (click)='onZoomOutClick($event)'>Zoom Out</button>
    </div>
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [rulerSettings]="rulerSettings" [scrollSettings]="scrollSettings">
        <e-nodes>
            <e-node id='node1' [offsetX]=300 [offsetY]=300>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public rulerSettings: RulerSettingsModel = { showRulers: true}
    public scrollSettings?: ScrollSettingsModel = {
        scrollLimit: 'Infinity',
    }
    public zoomInOptions: ZoomOptions = {
        type: 'ZoomIn',
        zoomFactor: 0.2,
        focusPoint: { x: 0.5, y: 0.5 },
    };
    public zoomOutOptions: ZoomOptions = {
        type: 'ZoomOut',
        zoomFactor: 0.2,
        focusPoint: { x: 0.5, y: 0.5 },
      };
    onZoomInClick = (args: MouseEvent) => {
        (this.diagram as Diagram).zoomTo(this.zoomInOptions);
        (this.diagram as Diagram).dataBind();
    }
    onZoomOutClick = (args: MouseEvent) => {
        (this.diagram as Diagram).zoomTo(this.zoomOutOptions);
        (this.diagram as Diagram).dataBind();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

For more information on various ways to zoom and pan the diagram, refer to zoom and pan with various methods.

AutoScroll

The autoscroll feature automatically scrolls the diagram when a node or connector is moved beyond the visible boundary. This functionality ensures that elements remain visible during operations such as dragging, resizing, and selection, providing a seamless user experience.

The autoscroll behavior activates automatically when any of the following actions occur near the edges of the diagram:

  • Node dragging or resizing operations
  • Connector control point editing
  • Rubber band selection

The client-side event ScrollChange is triggered when autoscroll occurs, enabling custom behavior implementation. Refer to the scrollChange event section for more information.

Autoscroll behavior can be enabled or disabled using the canAutoScroll property of the diagram.

Autoscroll Border

The autoscroll border defines the maximum distance from the mouse pointer to the diagram edge that triggers autoscroll behavior. By default, this distance is set to 15 pixels for all sides (left, right, top, and bottom). This distance can be customized using the autoScrollBorder property of the scroll settings.

The following example demonstrates how to configure autoscroll with custom border settings:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, PointModel, RulerSettingsModel, ScrollSettingsModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [rulerSettings]="rulerSettings" [scrollSettings]="scrollSettings">
        <e-nodes>
            <e-node id='node1' [offsetX]=200 [offsetY]=300 [width]=100 [height]=100>
                <e-node-annotations>
                    <e-node-annotation content="Drag or resize the node to activate autoscroll">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
        </e-nodes>
        <e-connectors>
            <e-connector id='connector' type='Orthogonal' [sourcePoint]='sourcePoint1' [targetPoint]='targetPoint1'>
                <e-connector-annotations>
                    <e-connector-annotation content='Adjust control point or end point to autoScroll' alignment='After'>
                    </e-connector-annotation>
                </e-connector-annotations>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public rulerSettings: RulerSettingsModel = { showRulers: true}
    public scrollSettings?: ScrollSettingsModel;
    public sourcePoint1?: PointModel;
    public targetPoint1?: PointModel;
    ngOnInit(): void {
        this.sourcePoint1 = { x: 100, y: 100 };
        this.targetPoint1 = { x: 300, y: 100 };
        this.scrollSettings = {
            scrollLimit: 'Infinity',
            canAutoScroll: true,
            autoScrollBorder: { left: 100, right: 100, top: 100, bottom: 100 },
        } as ScrollSettingsModel;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

NOTE

To use autoscroll, the scrollLimit should be set as ‘Infinity’.

Controlling Autoscroll Speed

The frequency of automatic scrolling in the Diagram component during autoscroll behavior can be precisely controlled. The scrolling frequency can be adjusted from slow and smooth to quick and rapid to suit different requirements. Configure this by setting a value in milliseconds to the autoScrollFrequency property within the scrollSettings, allowing precise control over autoscroll timing.

AutoscrollFrequency

Scroll Limit

The scrollLimit property allows developers to define the scrollable region of the diagram. It includes the following options:

  • Infinity: Allows scrolling in all directions without any restriction.
  • Diagram: Allows scrolling within the diagram region only.
  • Limited: Allows scrolling within a specified scrollable area.

The scrollLimit property in scroll settings helps to define these scrolling boundaries.

Scrollable Area

Scrolling beyond a particular rectangular area can be restricted by using the scrollableArea property in scrollSettings. To restrict scrolling beyond a custom region, set the scrollLimit to “limited” and define the desired bounds in the scrollableArea property.

The following code example illustrates how to specify the scroll limit and customize the scrollable area:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, Diagram, ScrollSettingsModel, RulerSettingsModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <div id='container'>
      <label>Scrollable Area</label>
      <select id="scrollLimit" (change)="onScrollLimitChange($event)">
        <option value="Limited">Limited</option>
        <option value="Infinity">Infinity</option>
        <option value="Diagram">Diagram</option>
      </select>
    </div>
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [scrollSettings]="scrollSettings" [rulerSettings]="rulerSettings">
        <e-nodes>
            <e-node id='node1' [offsetX]=150 [offsetY]=150 [width]=100 [height]=100>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public scrollSettings?: ScrollSettingsModel;
    public rulerSettings: RulerSettingsModel = { showRulers: true}
    ngOnInit(): void {
        // Defines the pageSettings for the diagram
        this.scrollSettings = {
            canAutoScroll: true,
            //Sets the scroll limit
            scrollLimit: 'Limited',
            //Sets the scrollable Area
            scrollableArea: {
                x: 0,
                y: 0,
                width: 1500,
                height: 1500
            }
        } as any;
    } 
    public onScrollLimitChange(args: any): void {
        (this.diagram as Diagram).scrollSettings.scrollLimit = args.target.value;
        (this.diagram as Diagram).dataBind();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Scroll Padding

The padding property of the scroll settings allows developers to extend the scrollable region based on the scroll limit. This property is useful for adding extra space around the diagram content, making it easier to navigate and interact with elements near the edges.

The following code example illustrates how to set scroll padding for the diagram region:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, NodeModel, ScrollSettingsModel,RulerSettingsModel, MarginModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [scrollSettings]="scrollSettings" [rulerSettings]="rulerSettings" [nodes] ="nodes">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    public nodes: NodeModel[] = [
        {
            id: 'Start',
            width: 100, height: 100,
            offsetX: 350, offsetY: 350,
        }]
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public scrollSettings?: ScrollSettingsModel;
    public rulerSettings: RulerSettingsModel = { showRulers: true};
    ngOnInit(): void {
        // Defines the pageSettings for the diagram
        this.scrollSettings = {
            //Sets the scroll limit
             padding: { left: 100, top: 100 }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Reset Scroll and Zoom Settings

The reset method resets both the zoom level and scroller offsets to their default values. This is useful for returning the diagram to its initial state after user interactions.

//Resets the scroll and zoom to default values
(this.diagram as Diagram).reset();

Update Viewport Dimensions

The updateViewPort method is used to update the dimensions of the diagram viewport. This method is typically called when the diagram container size changes or when dynamic resizing is required.

//Updates diagram viewport dimensions
(this.diagram as Diagram).updateViewPort();

Events

Scroll Change Event

The scrollChange event is triggered whenever the scrollbar is updated. This event occurs during actions such as zooming in, zooming out, using the mouse wheel, or panning. The following example shows how to capture and handle the scrollChange event:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, DiagramTools, IScrollChangeEventArgs } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px"  (scrollChange)="scrollChange($event)" [tool]='tool'>
        <e-nodes>
            <e-node id='node1' [offsetX]=150 [offsetY]=150 [width]=100 [height]=100>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public tool?: DiagramTools;
    ngOnInit(): void {
        this.tool = DiagramTools.ZoomPan
    }
    public scrollChange(args: IScrollChangeEventArgs): void {
        console.log(args.panState);
        // Handle scrollChange event for custom logic
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Scroll settings in EJ2 Vue Diagram control

21 Jul 202624 minutes to read

The Vue Diagram can be scrolled using both the vertical and horizontal scrollbars. Additionally, the mouse wheel can be used to scroll the diagram. The diagram’s scrollSettings allow you to read the current scroll status, view port size, current zoom level, and zoom factor. These settings also provide the capability to programmatically control the scrolling of the diagram.

Access and Customize Scroll Settings

Scroll settings in a diagram allow you to access and customize various properties such as horizontalOffset, verticalOffset, viewPortWidth, viewPortHeight, currentZoom, zoomFactor, maxZoom, minZoom, scrollLimit, canAutoScroll, autoScrollBorder, padding, scrollableArea.

These properties enable you to read and adjust the scroll status, scroll offset, zoom levels, and more. For a comprehensive overview of these properties, refer to the Scroll Settings

Define scroll offset

The diagram allows you to pan before loading, ensuring that any desired region of a large diagram is visible. You can programmatically pan the diagram using the horizontalOffset and verticalOffset properties of the scroll settings. The following code illustrates how to programmatically pan the diagram upon initialization also defined scrollLimit as ‘Infinity’ to scroll infinitely in diagram. To learn more about scrollLimit refer to scrollLimit

In the example below, the vertical scrollbar is scrolled down by 100 px, and the horizontal scrollbar is scrolled to the right by 100 px.

<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :scrollSettings='scrollSettings' :rulerSettings='rulerSettings'></ejs-diagram>
    </div>
</template>
<script setup>
import { onMounted, ref } from "vue";
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const diagram = ref(null);
const width = "750px";
const height = "500px";
const scrollSettings = {
    //To scroll the diagram infinitely
    scrollLimit: 'Infinity',
};
const rulerSettings = {
    showRulers: true
};
onMounted(function () {
    const diagramInstance = diagram.value.ej2Instances;
    diagramInstance.scrollSettings.horizontalOffset = 100;
    diagramInstance.scrollSettings.verticalOffset = 100;
    diagramInstance.dataBind();
})
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :scrollSettings='scrollSettings' :rulerSettings='rulerSettings'></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "100%",
            height: "500px",
            scrollSettings: {
              //To scroll the diagram infinitely
              scrollLimit: 'Infinity',
            },
            rulerSettings: {
              showRulers: true
            }
        }
    },
    mounted: function () {
      const diagramInstance = this.$refs.diagram.ej2Instances;
      diagramInstance.scrollSettings.horizontalOffset = 100;
      diagramInstance.scrollSettings.verticalOffset = 100;
      diagramInstance.dataBind();
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Update scroll offset at runtime

There are several ways to update the scroll offset at runtime:

  • Scrollbar: Use the horizontal and vertical scrollbars of the diagram.
  • Mousewheel: Scroll vertically with the mouse wheel. Hold the Shift key while scrolling to scroll horizontally.
  • Pan Tool: Activate the ZoomPan tool in the diagram to scroll by panning.
  • Touch: Use touch pad gestures for scrolling.

Programmatically update Scroll Offset

You can programmatically change the scroll offsets of diagram by customizing the horizontalOffset and verticalOffset of Scroll Settings at runtime. The following code illustrates how to change the scroll offsets at runtime.

<template>
    <div id="app">
        <ejs-button ref="updateScrollSettings" id="updateScrollSettings" >Update Scroll Settings</ejs-button>
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :scrollSettings='scrollSettings' :rulerSettings='rulerSettings'></ejs-diagram>
    </div>
</template>
<script setup>
import { onMounted, ref } from "vue";
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';

const diagram = ref(null);
const updateScrollSettings = ref(null);
const width = "750px";
const height = "350px";
const rulerSettings = { showRulers: true };
const scrollSettings = { scrollLimit: 'Infinity' };

onMounted(function () {
    const diagramInstance = diagram.value.ej2Instances;
    const updateScrollSettingsInstance = updateScrollSettings.value.ej2Instances;
    updateScrollSettingsInstance.element.onclick = () => {
        diagramInstance.scrollSettings.horizontalOffset = 200;
        diagramInstance.scrollSettings.verticalOffset = 200
        diagramInstance.dataBind();
    }
});
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-button ref="updateScrollSettings" id="updateScrollSettings" >Update Scroll Settings</ejs-button>
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :scrollSettings='scrollSettings' :rulerSettings='rulerSettings'></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent,
        'ejs-button': ButtonComponent,
    },
        data() {
        return {
            width: "100%",
            height: "500px",
            rulerSettings: { showRulers: true },
            scrollSettings: { scrollLimit: 'Infinity' },
        }
    },
        mounted: function () {
        const diagramInstance = this.$refs.diagram.ej2Instances;
        const updateScrollSettings = this.$refs.updateScrollSettings.ej2Instances;
        //Updates scroll settings
        updateScrollSettings.element.onclick = () => {
          diagramInstance.scrollSettings.horizontalOffset = 200;
          diagramInstance.scrollSettings.verticalOffset = 200
          diagramInstance.dataBind();
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Update zoom at runtime

Zoom using mouse wheel

Another way to zoom in and out the diagram is by using the mouse wheel. This method is a quick and convenient way to zoom in and out without having to use any additional tools or gestures.

  • Zoom in: Press Ctrl+mouse wheel, then scroll upward.

  • Zoom out: Press Ctrl+mouse wheel, then scroll downward.

Zoom using Keyboard Shortcuts

Using keyboard shortcuts is a quick and easy way to zoom the diagram without having to use the mouse or touch pad.

  • Zoom in: Press Ctrl and the plus(+) key.

  • Zoom out: Press Ctrl and the minus(-) key.

Programmatically update zoom

You can programmatically change the current zoom of diagram by utilizing the zoomTo public method.

ZoomOptions

The zoomTo method takes one parameter zoomOptions. In that zoomOptions we can specify the focusPoint, type and zoomFactor

The following example shows how to zoom-in and zoom-out the diagram using zoomTo method

<template>
    <div id="app">
        <ejs-button ref="zoomIn" id="zoomIn" >Zoom In</ejs-button>
        <ejs-button ref="zoomOut" id="zoomOut" >Zoom Out</ejs-button>
        <ejs-diagram ref="diagram" id="diagram" :width='width' :height='height' :nodes='nodes' :scrollSettings='scrollSettings' :rulerSettings='rulerSettings'></ejs-diagram>
    </div>
</template>
<script setup>
import { onMounted, ref } from "vue";
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';

const nodes = [{
    offsetX: 300,
    offsetY: 300,
}];

const diagram = ref(null);
const zoomIn = ref(null);
const zoomOut = ref(null);
const width = "750px";
const height = "350px";
const rulerSettings = { showRulers: true };
const scrollSettings = { scrollLimit: 'Infinity' };

onMounted(function () {
    const diagramInstance = diagram.value.ej2Instances;
    const zoomInInstance = zoomIn.value.ej2Instances;
    const zoomOutInstance = zoomOut.value.ej2Instances;
    zoomInInstance.element.onclick = () => {
        let zoomOptions = {
          type: 'ZoomIn',
          zoomFactor: 0.2,
          focusPoint: { x: 0.5, y: 0.5 },
        };
        diagramInstance.zoomTo(zoomOptions);
        diagramInstance.dataBind();
    }
    zoomOutInstance.element.onclick = () => {
        let zoomOptions = {
          type: 'ZoomOut',
          zoomFactor: 0.2,
          focusPoint: { x: 0.5, y: 0.5 },
        };
        diagramInstance.zoomTo(zoomOptions);
        diagramInstance.dataBind();
    }
});

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-button ref="zoomIn" id="zoomIn" >Zoom In</ejs-button>
        <ejs-button ref="zoomOut" id="zoomOut" >Zoom Out</ejs-button>
        <ejs-diagram ref="diagram" id="diagram" :width='width' :height='height' :nodes='nodes' :scrollSettings='scrollSettings' :rulerSettings='rulerSettings'></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';

let nodes = [{
    offsetX: 300,
    offsetY: 300,
}];

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent,
        'ejs-button': ButtonComponent,
    },
    data() {
        return {
            width: "100%",
            height: "700px",
            nodes: nodes,
            rulerSettings: { showRulers: true },
            scrollSettings: { scrollLimit: 'Infinity' },
        }
    },
    mounted: function () {
      const diagramInstance = this.$refs.diagram.ej2Instances;
      const zoomIn = this.$refs.zoomIn.ej2Instances;
      const zoomOut = this.$refs.zoomOut.ej2Instances;
      zoomIn.element.onclick = () => {
        let zoomOptions = {
          type: 'ZoomIn',
          zoomFactor: 0.2,
          focusPoint: { x: 0.5, y: 0.5 },
        };
        diagramInstance.zoomTo(zoomOptions);
        diagramInstance.dataBind();
      }
      zoomOut.element.onclick = () => {
        let zoomOptions = {
          type: 'ZoomOut',
          zoomFactor: 0.2,
          focusPoint: { x: 0.5, y: 0.5 },
        };
        diagramInstance.zoomTo(zoomOptions);
        diagramInstance.dataBind();
      }
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

For more information on various ways to zoom and pan the diagram, refer to zoomPan with various ways

AutoScroll

The autoscroll feature automatically scrolls the diagram when a node or connector is moved beyond its boundary. This ensures that the element remains visible during operations like dragging, resizing, and selection.

The autoscroll behavior triggers automatically when any of the following actions occur towards the edges of the diagram:

  • Node dragging or resizing
  • Connector control point editing
  • Rubber band selection

The client-side event ScrollChange is triggered when autoscroll occurs, allowing for customizations. Refer scrollChange-event for more information.

Autoscroll behavior can be enabled or disabled using the canAutoScroll property of the diagram.

Autoscroll border

The autoscroll border defines the maximum distance from the mouse pointer to the diagram edge that triggers autoscroll. By default, this distance is set to 15 pixels for all sides (left, right, top, and bottom). You can adjust this using the autoScrollBorder property of the scroll settings.

The following example demonstrates how to configure autoscroll:

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors' :scrollSettings='scrollSettings'
         :rulerSettings='rulerSettings'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, ConnectorConstraints, ConnectorEditing } from '@syncfusion/ej2-vue-diagrams';

const nodes = [{
  id: 'node1',
  width: 100,
  height: 60,
  offsetX: 200,
  offsetY: 300,
  annotations: [
    { content: 'Drag or resize the node to activate autoscroll' },
  ],
}];
const connectors = [{
  id: 'con1',
  type: 'Bezier',
  segments: [{ type: 'Bezier', point: { x: 150, y: 100 } }],
  sourcePoint: { x: 100, y: 100 },
  targetPoint: { x: 300, y: 100 },
  annotations: [
    {
      content: 'Adjust control point or end point to autoScroll',
      alignment: 'After',
    },
  ],
  constraints:
    ConnectorConstraints.Default |
    ConnectorConstraints.DragSegmentThumb,
}]
const width = "750px";
const height = "700px";
const rulerSettings = { showRulers: true };
const scrollSettings = {
    canAutoScroll: true,
    scrollLimit: 'Infinity',
    autoScrollBorder: {
        left: 100,
        right: 100,
        top: 100,
        bottom: 100
    }
}
provide('diagram', [ConnectorEditing]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors' :scrollSettings='scrollSettings' :rulerSettings='rulerSettings'></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent, ConnectorConstraints, ConnectorEditing } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
  id: 'node1',
  width: 100,
  height: 60,
  offsetX: 200,
  offsetY: 300,
  annotations: [
    { content: 'Drag or resize the node to activate autoscroll' },
  ],
}];

let connectors = [{
  id: 'con1',
  type: 'Bezier',
  segments: [{ type: 'Bezier', point: { x: 150, y: 100 } }],
  sourcePoint: { x: 100, y: 100 },
  targetPoint: { x: 300, y: 100 },
  annotations: [
    {
      content: 'Adjust control point or end point to autoScroll',
      alignment: 'After',
    },
  ],
  constraints:
    ConnectorConstraints.Default |
    ConnectorConstraints.DragSegmentThumb,
}];

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "100%",
            height: "700px",
            nodes: nodes,
            connectors: connectors,
            //Enables ruler to see the scroll offset
            rulerSettings: { showRulers: true },
            scrollSettings: {
                canAutoScroll: true,
                //Enable autoScroll
                scrollLimit: 'Infinity',
                //Defines the autoScroll border of all the sides of diagram
                autoScrollBorder: {
                    left: 100,
                    right: 100,
                    top: 100,
                    bottom: 100
                }
            },
        }
    },
    provide: {
      diagram: [ConnectorEditing]
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

NOTE

To use auto scroll the scrollLimit should be set as ‘Infinity’

Controlling Autoscroll Speed

You can control how often the scrolling needs to be performed automatically in the Diagram component during the auto-scrolling behavior. You can now adjust the frequency, ranging from slow and smooth to quick and rapid, to suit their preferences. To configure, set the value in milliseconds to the autoScrollFrequency property within the scrollSettings class, allowing precise control over how often auto-scrolling occurs.

AutoscrollFrequency GIF

Scroll limit

The scrollLimit allows you to define the scrollable region of the diagram. It includes the following options:

  • Infinity: Allows scrolling in all directions without any restriction.
  • Diagram: Allows scrolling within the diagram region.
  • Limited: Allows scrolling within a specified scrollable area.

The scrollLimit property in scroll settings helps to define these limits.

Scrollable Area

Scrolling beyond a particular rectangular area can be restricted by using the scrollableArea property in scrollSettings. To restrict scrolling beyond a custom region, set the scrollLimit to “limited” and define the desired bounds in scrollableArea property.

The following code example illustrates how to specify the scroll limit and customize the scrollable area.

<template>
    <div id="app">
        <div style="display: flex; align-items: center; margin-bottom: 10px;">
          <label style="margin-right: 10px;">Scrollable Area</label>
          <ejs-dropdownlist id='scrollableArea' ref='scrollableArea' :enabled=true :value='scrollableAreaValue' :dataSource='scrollableArea' @change="onScrollableAreaChange"/>
        </div>
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' :scrollSettings='scrollSettings' :rulerSettings='rulerSettings'
         ></ejs-diagram>
    </div>
</template>
<script setup>
import { onMounted, ref } from "vue";
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';
import { DropDownListComponent as EjsDropdownlist } from "@syncfusion/ej2-vue-dropdowns";

let nodes = [{
    id: 'Start',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
}];
const diagram = ref(null);
const width = "750px";
const height = "350px";
// set the autoScrollBorder
const scrollSettings = {
    canAutoScroll: true,
    //Sets the scroll limit
    scrollLimit: 'Limited',
    //Sets the scrollable Area
    scrollableArea: {
        x: 0,
        y: 0,
        width: 1000,
        height: 1000
    }
}
const rulerSettings = { showRulers: true };
const scrollableArea = [
  { shape: 'Limited', text: 'Limited' },
  { shape: 'Infinity', text: 'Infinity' },
  { shape: 'Diagram', text: 'Diagram' },
];


function onScrollableAreaChange(args) {
    const diagramInstance = diagram.value.ej2Instances;
    diagramInstance.scrollSettings.scrollLimit = args.itemData.shape;
    diagramInstance.dataBind();
}

const scrollableAreaValue = 'Limited';
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <div style="display: flex; align-items: center; margin-bottom: 10px;">
          <label style="margin-right: 10px;">Scrollable Area</label>
          <ejs-dropdownlist id='scrollableArea' ref='scrollableArea' :enabled=true :value='scrollableAreaValue' :dataSource='scrollableArea' @change="onScrollableAreaChange"/>
        </div>
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' :scrollSettings='scrollSettings' :rulerSettings='rulerSettings'
         ></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';
import { DropDownListComponent } from "@syncfusion/ej2-vue-dropdowns";

let nodes = [{
    id: 'Start',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
}];
let data = [
  { shape: 'Limited', text: 'Limited' },
  { shape: 'Infinity', text: 'Infinity' },
  { shape: 'Diagram', text: 'Diagram' },
];

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent,
        'ejs-dropdownlist': DropDownListComponent,
    },
    data() {
        return {
            width: "100%",
            height: "500px",
            nodes: nodes,
            scrollableAreaValue: 'Limited',
            scrollableArea: data,
            //scrollableAreaChange: onScrollableAreaChange,
            rulerSettings: { showRulers: true },
            // set the autoScrollBorder
            scrollSettings: {
                canAutoScroll: true,
                //Sets the scroll limit
                scrollLimit: 'Limited',
                //Sets the scrollable Area
                scrollableArea: {
                    x: 0,
                    y: 0,
                    width: 1000,
                    height: 1000
                }
            },
        }
    },
    methods: {
      // Method to update scroll limit based on dropdown selection
      onScrollableAreaChange(args) {
          const diagramInstance = this.$refs.diagram.ej2Instances;
          diagramInstance.scrollSettings.scrollLimit = args.itemData.shape;
          diagramInstance.dataBind();
      }
  },
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Scroll Padding

The padding property of the scroll settings allows you to extend the scrollable region based on the scroll limit. This property is useful for adding extra space around the diagram content, making it easier to navigate and interact with elements near the edges.

The following code example illustrates how to set scroll padding for the diagram region:

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :rulerSettings='rulerSettings'
            :scrollSettings='scrollSettings'></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
    id: 'Start',
    width: 100, height: 100,
    offsetX: 250, offsetY: 250,
}];

const width = "750px";
const height = "500px";
const rulerSettings = { showRulers: true };
// set the autoScrollBorder
const scrollSettings = {
    canAutoScroll: true,
    scrollLimit: 'Infinity',
    //Sets the scroll limit
    padding: { left: 100, top: 100 }
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :rulerSettings='rulerSettings'
            :scrollSettings='scrollSettings'></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
    id: 'Start',
    width: 100, height: 100,
    offsetX: 250, offsetY: 250,
}];

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "100%",
            height: "500px",
            nodes: nodes,
            rulerSettings: { showRulers: true },
            // set the autoScrollBorder
            scrollSettings: {
                canAutoScroll: true,
                scrollLimit: 'Infinity',
                //Sets the scroll padding
                padding: { left: 100, top: 100 }
            },
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Reset scroll

The reset method resets the zoom and scroller offsets to their default values.

//Resets the scroll and zoom to default values
 diagramInstance.reset();

UpdateViewport

The updateViewPort method is used to update the dimensions of the diagram viewport.

//Updates diagram viewport
diagramInstance.updateViewPort();

Events

Scroll change event

The scrollChange event is triggered whenever the scrollbar is updated. This can occur during actions such as zooming in, zooming out, using the mouse wheel, or panning. The following example shows how to capture the scrollChange event.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :scrollSettings='scrollSettings'
        :tool='tool' :scrollChange="scrollChange"></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram, DiagramTools } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
    id: 'Start',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [{
        id: 'label1',
        content: 'Start'
    }],
}];

const width = "750px";
const height = "500px";
const tool = DiagramTools.ZoomPan;
const scrollChange = (args) => {
    //Triggers while interacting with diagram and performing undo-redo
    console.log(args.panState);
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :scrollSettings='scrollSettings'
        :tool='tool' :scrollChange="scrollChange"></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent, DiagramTools } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
    id: 'Start',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [{
        id: 'label1',
        content: 'Start'
    }],
}];

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "100%",
            height: "500px",
            nodes: nodes,
            tool: DiagramTools.ZoomPan,
            scrollChange: (args) => {
              //Triggers while interacting with diagram and performing undo-redo
              console.log(args.panState);
            }
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>